public class MessageBuilder {

    private Message message = new Message();
    
    private Alphabet alphabet = new Alphabet();
    
    private Object lastPresented = null;
    
    private Presenter presenter = new Presenter();
    
    private boolean spacePresented = false;
    
    public synchronized void handleSelection() {
        if (lastPresented instanceof Letter) {
            if (((Letter)lastPresented).getValue() == ' ') {
                message.endLastWord();
                presenter.presentMessage(message);
            } else {
                message.addLetter((Letter)lastPresented);
                spacePresented = false;
            }
            alphabet.reset();
        }
        // code to handle words, sentences, and commands not shown
        // if present, would have consisted of increasingly complex
        // sets of if statements
    }
    
    public synchronized void handleTimeout() {
        // this code only shows the processing of
        // the first two letters of a word
        if (message.gettingFirstLetterOfWord()) {
            lastPresented = alphabet.nextLetter();
            presenter.presentLetter((Letter)lastPresented);
            return;
        }
        
        if (!spacePresented) {
            lastPresented = new Letter(' ');
            presenter.presentLetter((Letter)lastPresented);
            spacePresented = true;
        } else {
            lastPresented = alphabet.nextLetter();
            presenter.presentLetter((Letter)lastPresented);
        }

        // code to handle words, commands, and sentences not shown
        // code to "suspend" building a message not shown
    }
}
