public class GuessingLettersAndSpace extends MessageState {

    private boolean spacePresented = false;

    public MessageState handleTimeout(MessageBuilder builder) {
        Letter nextLetter = null;
        if (!spacePresented) {
            nextLetter = new Letter(' ');
            spacePresented = true;
        } else {
            nextLetter = builder.getAlphabet().nextLetter();
        }
        builder.setLastPresented(nextLetter);
        builder.getPresenter().presentLetter(nextLetter);
        return this;
    }
    
    public MessageState handleSelection(MessageBuilder builder) {
        MessageState newState = null;
        Letter letter = (Letter)builder.getLastPresented();
        if (letter.getValue() == ' ') {
            builder.getMessage().endLastWord();
            builder.getPresenter().presentMessage(builder.getMessage());
            newState = new GuessingLettersOnly();
        } else {
            builder.getMessage().addLetter(letter);
            spacePresented = false;
            builder.getAlphabet().reset();
            newState = this;
        }
        return newState;
    }
}
