public class MessageBuilder {

    private Message message = new Message();

    private Guess selection = null;

    private Guesser guesser = new Guesser();
    
    private Presenter presenter = new Presenter();
    
    public synchronized void handleSelection() {
        selection.addTo(message);
        if (selection instanceof Letter) {
            Letter l = (Letter)selection;
            if (l.getValue() == ' ') {
                presenter.presentMessage(message);
            }
        }
    }
    
    public synchronized void handleTimeout() {
        selection = guesser.nextGuess(message);
        selection.presentTo(presenter);
    }

}
